package com.sun.media.sound;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.ShortMessage;

public final class SoftShortMessage extends ShortMessage
{
    int channel;
    
    public SoftShortMessage() {
        this.channel = 0;
    }
    
    @Override
    public int getChannel() {
        return this.channel;
    }
    
    @Override
    public void setMessage(int command, int channel, int data1, int data2) throws InvalidMidiDataException {
        super.setMessage(command, (this.channel = channel) & 0xF, data1, data2);
    }
    
    @Override
    public Object clone() {
        SoftShortMessage softShortMessage = new SoftShortMessage();
        try {
            softShortMessage.setMessage(this.getCommand(), this.getChannel(), this.getData1(), this.getData2());
        }
        catch (InvalidMidiDataException cause) {
            throw new IllegalArgumentException(cause);
        }
        return softShortMessage;
    }
}
